import router, { asyncRoutes, resetRouter } from './router'
import store from './store'
// import { Message } from 'element-ui'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
import getPageTitle from '@/utils/get-page-title'

NProgress.configure({ showSpinner: false }) // NProgress Configuration

const whiteList = ['/login'] // no redirect whitelist

router.beforeEach(async(to, from, next) => {
  // start progress bar
  NProgress.start()

  // set page title
  document.title = getPageTitle(to.meta.title)

  // determine whether the user has logged in
  const hasToken = store.getters.token

  if (hasToken) {
    if (to.path === '/login') {
      // if is logged in, redirect to the home page
      next({ path: '/' })
      NProgress.done()
    } else {
      if (to.name) {
        if (to.path === '/reagent/mainoverview/index') {
          store.commit('settings/CHANGE_SETTING', { key: 'isMain', value: true })
        } else {
          store.commit('settings/CHANGE_SETTING', { key: 'isMain', value: false })
        }
        if (to.path.indexOf('reagent') !== -1) {
          store.commit('user/SET_CLASS', 'reagent')
        }
        if (to.path.indexOf('user') !== -1) {
          store.commit('user/SET_CLASS', 'user')
        }
        next()
      } else {
        if (to.path.indexOf('reagent') !== -1) {
          store.commit('user/SET_CLASS', 'reagent')
        }
        if (to.path.indexOf('user') !== -1) {
          store.commit('user/SET_CLASS', 'user')
        }
        store.commit('permission/SET_ROUTES', asyncRoutes)
        resetRouter()
        router.addRoutes(asyncRoutes)
        next({ ...to, replace: true })
      }
      // const hasGetUserInfo = store.getters.name
      // if (hasGetUserInfo) {
      //   next()
      // } else {
      //   try {
      //     // get user info
      //     // await store.dispatch('user/getInfo')
      //
      //     next()
      //   } catch (error) {
      //     // remove token and go to login page to re-login
      //     // await store.dispatch('user/resetToken')
      //     Message.error(error || 'Has Error')
      //     next(`/login?redirect=${to.path}`)
      //     NProgress.done()
      //   }
      // }
    }
  } else {
    /* has no token*/

    if (whiteList.indexOf(to.path) !== -1) {
      // in the free login whitelist, go directly
      next()
    } else {
      // other pages that do not have permission to access are redirected to the login page.
      next(`/login?redirect=${to.path}`)
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
